package uk.co.his.test.simpleol5;

import java.util.Map;
import java.util.Vector;

import org.eclipse.persistence.descriptors.ClassDescriptor;
import org.eclipse.persistence.descriptors.DescriptorEvent;
import org.eclipse.persistence.descriptors.DescriptorEventListener;
import org.eclipse.persistence.descriptors.DescriptorEventManager;
import org.eclipse.persistence.internal.sessions.ChangeRecord;
import org.eclipse.persistence.internal.sessions.ObjectChangeSet;
import org.eclipse.persistence.sessions.Session;

public class Customizer implements org.eclipse.persistence.config.SessionCustomizer {
	
	public Customizer()
	{
		System.err.println("The Customizer has been started");
	}

	//@Override
	public void customize(Session session) throws Exception {
		System.err.println("Customize a " + session);
		System.err.println("Customize session called " + session.getName());
		for (ClassDescriptor descriptor : session.getDescriptors().values()) {
			if(descriptor.getJavaClass() == Container.class || descriptor.getJavaClass() == Item.class) {
				System.out.println("Found Container or Item descriptor");
				descriptor.getEventManager().addListener(new DescriptorEventListener() {

					private void checkObjects(Item source, Item original, String eventName) {
						String sourceStr = source==null?"null":(source.toString());
						String originalStr = original==null?"null":(original.toString());
						String info = eventName + ": source=" + sourceStr +", original=" + originalStr;
						System.out.println(info);
					}
					
					private void checkObjects(Container source, Container original, String eventName) {
						String sourceStr = source==null?"null":(source.toString());
						String originalStr = original==null?"null":(original.toString());
						String info = eventName + ": source=" + sourceStr +", original=" + originalStr;
						System.out.println(info);
					}
					
					private void processEvent(DescriptorEvent event) {
						if(event.getSource() instanceof Container) {
							checkObjects((Container)event.getSource(), (Container)event.getOriginalObject(), eventCodeToString(event.getEventCode()));
						}
						if(event.getSource() instanceof Item) {
							checkObjects((Item)event.getSource(), (Item)event.getOriginalObject(), eventCodeToString(event.getEventCode()));
						}
					}
					
					private String eventCodeToString(int eventCode) {
						switch(eventCode) {
						case DescriptorEventManager.PreWriteEvent :
							return "PreWriteEvent";
						case DescriptorEventManager.PostWriteEvent :
							return "PostWriteEvent";
						case DescriptorEventManager.PreDeleteEvent :
							return "PreDeleteEvent";
						case DescriptorEventManager.PostDeleteEvent :
							return "PostDeleteEvent";
						case DescriptorEventManager.PreInsertEvent :
							return "PreInsertEvent";
						case DescriptorEventManager.PostInsertEvent :
							return "PostInsertEvent";
						case DescriptorEventManager.PreUpdateEvent :
							return "PreUpdateEvent";
						case DescriptorEventManager.PostUpdateEvent :
							return "PostUpdateEvent";
						case DescriptorEventManager.PostBuildEvent :
							return "PostBuildEvent";
						case DescriptorEventManager.PostRefreshEvent :
							return "PostRefreshEvent";
						case DescriptorEventManager.PostCloneEvent :
							return "PostCloneEvent";
						case DescriptorEventManager.PostMergeEvent :
							return "PostMergeEvent";
						case DescriptorEventManager.AboutToInsertEvent :
							return "AboutToInsertEvent";
						case DescriptorEventManager.AboutToUpdateEvent :
							return "AboutToUpdateEvent";
						case DescriptorEventManager.AboutToDeleteEvent :
							return "AboutToDeleteEvent";
						case DescriptorEventManager.PrePersistEvent :
							return "PrePersistEvent";
						case DescriptorEventManager.PreRemoveEvent :
							return "PreRemoveEvent";
						case DescriptorEventManager.PreUpdateWithChangesEvent :
							return "PreUpdateWithChangesEvent";
						}
						return "Unknown event";
					}
					
					private boolean override(int eventCode) {
						switch(eventCode) {
						case DescriptorEventManager.PreWriteEvent :
							return true;
						case DescriptorEventManager.PostWriteEvent :
						case DescriptorEventManager.PreDeleteEvent :
						case DescriptorEventManager.PostDeleteEvent :
						case DescriptorEventManager.PreInsertEvent :
						case DescriptorEventManager.PostInsertEvent :
						case DescriptorEventManager.PreUpdateEvent :
						case DescriptorEventManager.PostUpdateEvent :
						case DescriptorEventManager.PostBuildEvent :
						case DescriptorEventManager.PostRefreshEvent :
						case DescriptorEventManager.PostCloneEvent :
						case DescriptorEventManager.PostMergeEvent :
						case DescriptorEventManager.AboutToInsertEvent :
						case DescriptorEventManager.AboutToUpdateEvent :
						case DescriptorEventManager.AboutToDeleteEvent :
						case DescriptorEventManager.PrePersistEvent :
						case DescriptorEventManager.PreRemoveEvent :
						case DescriptorEventManager.PreUpdateWithChangesEvent :
						}
						return false;
					}

					//@Override
					public void aboutToInsert(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void aboutToUpdate(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postBuild(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postClone(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postMerge(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postRefresh(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void preInsert(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void preUpdateWithChanges(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void aboutToDelete(DescriptorEvent event) {
						processEvent(event);
						
					}

					//@Override
					public boolean isOverriddenEvent(DescriptorEvent event, @SuppressWarnings("rawtypes") Vector eventManagers) {
						System.out.println("********************* !!!!Ask for Override");
						processEvent(event);
						return override(event.getEventCode());
					}

					//@Override
					public void postDelete(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postInsert(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postUpdate(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void postWrite(DescriptorEvent event) {
						
						processEvent(event);
					}

					//@Override
					public void preDelete(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void prePersist(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void preRemove(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void preUpdate(DescriptorEvent event) {
						processEvent(event);
					}

					//@Override
					public void preWrite(DescriptorEvent event) {
						if(event.getObject() instanceof Item) {
							Item source = (Item) event.getObject();
							source.preUpdatePersist();
							event.updateAttributeWithObject("item_idx", source.getItemIndex());
						}
						/*
						if(event.getObject() instanceof Container) {
							Container source = (Container) event.getObject();
							source.z_updateIndices();
							event.applyAttributeValuesIntoRow("items");
						}
						*/
						/*
						if(event.getObject() instanceof Container) {
							Container source = (Container) event.getObject();
							event.updateAttributeWithObject("items", source.getItemsClone());
						}
						*/
						processEvent(event);
					}
					
				});
			}
		}
	}

}
