package uk.co.his.test.simpleol5;

import java.util.UUID;

import javax.persistence.Basic;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.Version;


@Entity
@NamedQueries({
})
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn
public class Item {

	
	@Id
	private String id;
	
	@Version private int version;

    @Basic
    private int item_idx;
    
    @Basic int creationOrder;

    @Basic String creationTime;
    
    @Basic String timestamp;
    
    public String getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(String timestamp) {
		this.timestamp = timestamp;
	}
	

	public int getCreationOrder() {
		return creationOrder;
	}

	public void setCreationOrder(int creationOrder) {
		this.creationOrder = creationOrder;
	}

	public Item(int creationOrder) {
    	this.creationOrder = creationOrder;
    	this.creationTime = Container.createTimestamp();
    }
    
    @SuppressWarnings("unused")
	private Item() {}
    
	@ManyToOne(fetch=FetchType.LAZY)
    private Container container;
	
	protected void setContainer(Container container) {
		this.container = container;
	}

	public void setUUID() {
		id = UUID.randomUUID().toString();
	}

	public void setItemIndex(int index) {
		if(index != item_idx) {
			System.out.println(this + " item_idx changed from " + item_idx + " to " + index);
			item_idx = index;
		}
	}
	
	public int getItemIndex() {
		return item_idx;
	}

	public String toString() {
		return "Item " + this.hashCode() + " id=" + id + ", creationOrder=" + creationOrder + ", item_idx=" + item_idx +  ", creationTime=" + creationTime + ", timestamp=" + timestamp + ", version=" + version;
	}
	
	public void preUpdatePersist() {
		System.out.println("!!!preUpdatePersist " + this);
		if(container != null && !container.isUpdatedIndices()) {
			container.z_updateIndices();
		}
	}
}
