package uk.co.his.test.simpleol5;

import java.util.ArrayList;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import uk.co.his.test.TestException;


public class Main {

	private static final int NumItemsPerContainer = 3; 
	private static final int NumItemsPerContainerToInsert = 3; 
	private static final int NumContainers = 2; 
	
	
	public static void log(String msg) {
		System.err.flush();
		System.out.flush();
		System.out.println(msg);
	}
	
	private static void printOutState(Singleton singleton) {
		for(Container container: singleton.getContainers()) {
			System.out.println(container);
			System.out.println(container.getItemsStr());
		}
	}
	
	public static void runContainerTest() throws TestException {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("TestSimpleOrderedLists5_memPU");
		ArrayList<Integer> order = new ArrayList<Integer>();
		
		
		
		log("1: Start BL!");
		EntityManager em = emf.createEntityManager();
		em.getTransaction().begin();
		
		Singleton singleton = Singleton.getInstance(em);
		singleton = Singleton.getInstance(em);
		boolean doneOne = false;
		for(int i = 1; i <= NumContainers; i++) {
			Container cont = singleton.containerAddNew(new Container(), em);
			for(int j = 1; j <= NumItemsPerContainer; j++) {
				cont.itemsAddNew(new Item(j), em);
				if(!doneOne)
					order.add(j);
			}
			doneOne = true;
		}
		printOutState(singleton);
		singleton = null;
		
		log("1: Commit it!");
		em.getTransaction().commit();
		em.close();
		log("1: Committed!");
		
		
		
		log("2: Start BL!");
		em = emf.createEntityManager();
		em.getTransaction().begin();

		singleton = Singleton.getInstance(em);
		doneOne = false;
		for(Container container: singleton.getContainers()) {
			int creationIndex = NumItemsPerContainer;
			for(int j = 0; j < NumItemsPerContainerToInsert; j++) {
				container.insertNewItemAtStart(new Item(++creationIndex), em);
				if(!doneOne)
					order.add(0, creationIndex);
			}
			doneOne = true;
		}
		printOutState(singleton);
		singleton = null;
		
		log("2: Commit it!");
		em.getTransaction().commit();
		em.close();
		log("2: Committed!");

		

		log("3: Start BL!");
		em = emf.createEntityManager();
		em.getTransaction().begin();
		
		singleton = Singleton.getInstance(em);
		printOutState(singleton);
		singleton = null;

		log("3: Commit it!");
		em.getTransaction().commit();
		em.close();
		log("3: Committed!");
		
		
		
		log("4: Start BL!");
		em = emf.createEntityManager();
		em.getTransaction().begin();
		
		singleton = Singleton.getInstance(em);

		printOutState(singleton);
		try {
			singleton.validate(order.toArray(new Integer[0]));
		} catch (TestException e) {
			System.err.println(e);
			throw e;
		}
		singleton = null;

		log("4: Commit it!");
		em.getTransaction().commit();
		em.close();
		log("4: Committed!");
		
		
		
		log("Dones!");
	}
	
	
	/**
	 * @param args 
	 * @throws TestException 
	 */
	public static void main(String[] args) throws TestException  {

		runContainerTest();

	}

}
