package uk.co.his.test.simpleol5;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.OneToMany;
import javax.persistence.Version;

import uk.co.his.test.TestException;



@Entity
@NamedQueries({
})
public class Singleton {

	@SuppressWarnings("unused")
	@Version private int version;
	
	@Id
	protected String id = "1";

	public static Singleton getInstance(EntityManager em) {
		Singleton c = em.find(Singleton.class, "1");
		if (c == null) {
			c = new Singleton();
			em.persist(c);
		}
		return c;
	}
	
	@OneToMany(cascade=CascadeType.ALL, mappedBy="singleton")
    private java.util.Set<Container>  containers  = new java.util.HashSet<Container>();
	
	protected  Container containerAddNew(Container newObj, EntityManager em) {
	    newObj.setUUID();
	    newObj.setTimestamp(createTimestamp());
	    em.persist(newObj);
	    containers.add(newObj);
	    newObj.setSingleton(this);
	    return newObj;
	}
	
	public java.util.Set<Container> getContainers() {
		return containers;
	}
	

	private static String createTimestamp()
	{
		DateFormat df = new SimpleDateFormat("dd-MMM-yyyy hh:mm:ss", Locale.UK); 
		df.setTimeZone(TimeZone.getTimeZone("GB"));
		return df.format(new Date());
	}
	
	public void validate(Integer[] order) throws TestException {
		for(Container c: containers) {
			c.validate(order);
		}
	}
}
